#include "PalmOS.h"
#include "PointerHackConfig_rcp.h"
#include "PointerHack.h"

#pragma segment 2000


Boolean ConfigEventHandler(EventPtr eventP);
void Tune(AppPrefPtr prefP);
void DisplayCurrent(FormPtr frmP, AppPrefPtr prefs);
void initPrefs(AppPrefPtr prefP);
void savePrefs(AppPrefPtr prefP);
void loadPrefs(AppPrefPtr prefP);
static void SetFieldText(Int16 nFieldName, char * sNewText);
char *GetFieldText(Int16 nFieldName);

// Program

Boolean ConfigEventHandler(EventPtr eventP)
{
    Boolean handled = false;
    
    FormPtr frmP = FrmGetActiveForm();
    //FieldPtr fieldP;
    //MemHandle textH;
    //MemPtr memP;
    char *cText;

    AppPrefType prefs;

    loadPrefs(&prefs);
    
    switch (eventP->eType)
    {
        case frmOpenEvent :
            FrmDrawForm(frmP);
            DisplayCurrent(frmP, &prefs);
            break;

        case frmUpdateEvent :                     
            handled = true;
            break;

        case ctlSelectEvent :
        {
            switch (eventP->data.ctlSelect.controlID)
            {
                case TUNE_BUTTON :
                    Tune(&prefs);
                    savePrefs(&prefs);
                    //from the HackMaster API
                    FrmGotoForm(2000);
                    handled = true;
                    break;

                case DEFAULT_BUTTON :
                    initPrefs(&prefs);
                    savePrefs(&prefs);
                    //from the HackMaster API
                    FrmGotoForm(2000);
                    handled = true;
                    break;

                case OK_BUTTON :
                    cText = GetFieldText(FLD_ENABLE_CHAR);
                    if (cText == NULL || StrLen(cText) == 0)
                    {
                       FrmAlert(ALERT_INVALID_CHAR);
                    }
                    else
                    {
                        prefs.EnableChar = cText[0];
                        savePrefs(&prefs);
                        FtrSet(CREATOR_ID, FTR_NUMBER_ENABLECHAR, prefs.EnableChar);
                        //WinDrawChars(&prefs.EnableChar,1,0,120);
                        //from the HackMaster API
                        FrmGotoForm(9000);
                    }

                    handled = true;
                    break;
            }
        }
        default :
            handled = false;
            break;
    }
    return handled;
}

void Tune(AppPrefPtr prefs)
{
      char PosT[8],
              XPosT[4],
              YPosT[4];

      char sTemp[100];

      Boolean IsCentreCorrect = false;
      Boolean IsXMagnificationCorrect = false;
      Boolean IsYMagnificationCorrect = false;

      PointType ptPenPosition;   
      Boolean IsPenDown = false;
      Int16 ScrX = 0;
      Int16 ScrY = 0;
      Int32 ValX;
      Int32 ValY;
      Boolean FoundXAbove, FoundYAbove, FoundXBelow, FoundYBelow;
      Int32 ValXAbove = 0;
      Int32 ValYAbove = 0;
      Int32 ValXBelow = 0;
      Int32 ValYBelow = 0;

      RectangleType rP;

      ValX = 100;
      ValY = 100;                   
      
      //Clearing screen
      rP.topLeft.x = 0;
      rP.topLeft.y = 20;
      rP.extent.x = 160;
      rP.extent.y = 40;
      WinEraseRectangle(&rP,0);
      
      //Display Labels
      StrCopy(sTemp, "Digitizer (Width,Height): ");
      WinDrawChars(sTemp, StrLen(sTemp), 1, 25); 
      StrCopy(sTemp, "Magnification (X,Y) : ");
      WinDrawChars(sTemp, StrLen(sTemp), 1, 40); 

      FoundXAbove = false;
      FoundYAbove = false;
      FoundXBelow = false;
      FoundYBelow = false;
      while (!IsCentreCorrect)
      {
          EvtFlushPenQueue();
          ptPenPosition.x = ValX - 80;  
          ptPenPosition.y = ValY - 80;
          EvtEnqueuePenPoint(&ptPenPosition);
          EvtGetPen(&ScrX, &ScrY, &IsPenDown);
          EvtFlushPenQueue();

          if (ScrX == 79)
          {
            FoundXBelow = true;
            ValXBelow = ValX;
          }
          if (ScrX == 81)
          {
            FoundXAbove = true;
            ValXAbove = ValX;
          }
          if (ScrY == 79)
          {
            FoundYBelow = true;
            ValYBelow = ValY;
          }
          if (ScrY == 81)
          {
            FoundYAbove = true;
            ValYAbove = ValY;
          }
          
          if (ScrX < 80) 
                ValX -= 1;
          else
              if (ScrX > 80) 
                ValX += 1;
          
          if (ScrY < 80) 
                ValY -= 1;
          else
              if (ScrY > 80) 
                    ValY += 1;
          
          if (FoundXBelow && FoundXAbove && ScrX != 80)
          {
            ScrX = 80;
            ValX = (ValXAbove + ValXBelow) / 2;
          }
          if (FoundYBelow && FoundYAbove && ScrY != 80)
          {
            ScrY = 80;
            ValY = (ValYAbove + ValYBelow) / 2;
          }
          
          if (ScrX == 80 && ScrY == 80)
          {
            IsCentreCorrect = true;      
            prefs->DigMaxX = ValX;      
            prefs->DigMaxY = ValY;      
          }

          StrIToA(XPosT,ValX);
          StrIToA(YPosT,ValY);
          StrCopy(PosT,XPosT);
          StrCat(PosT,",");
          StrCat(PosT,YPosT);
          WinDrawChars(PosT,StrLen(PosT),110,25);
      }

      //Calc X (point of 159,80)
      ValX = 80;

      FoundXAbove = false;
      FoundXBelow = false;
      while (!IsXMagnificationCorrect)
      {
          EvtFlushPenQueue();
          ptPenPosition.x = prefs->DigMaxX - (80-(((((80-159)*100)/80) * ValX)/100));
          ptPenPosition.y = prefs->DigMaxY - 80;
          EvtEnqueuePenPoint(&ptPenPosition);
          EvtGetPen(&ScrX, &ScrY, &IsPenDown);
          EvtFlushPenQueue();

          if (ScrX == 158)
          {
            FoundXBelow = true;
            ValXBelow = ValX;
          }
          if (ScrX ==160)
          {
            FoundXAbove = true;
            ValXAbove = ValX;
          }

          if (ScrX < 159) 
                ValX += 1;
          else
              if (ScrX > 159) 
                ValX -= 1;
          
          if (FoundXBelow && FoundXAbove && ScrX != 159)
          {
            ScrX = 159;
            ValX = (ValXAbove + ValXBelow) / 2;
          }

          if (ScrX == 159)
          {
            IsXMagnificationCorrect = true;      
            prefs->MagDigX = ValX;      
          }
      }

      //Calc Y (point of 80,159)
      ValY = 80;
      FoundYAbove = false;
      FoundYBelow = false;
      while (!IsYMagnificationCorrect)
      {
          EvtFlushPenQueue();
          ptPenPosition.x = prefs->DigMaxX - 80;
          ptPenPosition.y = prefs->DigMaxY - (80-(((((80-159)*100)/80) * ValY)/100));
          EvtEnqueuePenPoint(&ptPenPosition);
          EvtGetPen(&ScrX, &ScrY, &IsPenDown);
          EvtFlushPenQueue();

          if (ScrY == 158)
          {
            FoundYBelow = true;
            ValYBelow = ValY;
          }
          if (ScrY ==160)
          {
            FoundYAbove = true;
            ValYAbove = ValY;
          }

          if (ScrY < 159) 
                ValY += 1;
          else
              if (ScrY > 159) 
                ValY -= 1;
          
          if (FoundYBelow && FoundYAbove && ScrY != 159)
          {
            ScrY = 159;
            ValY = (ValYAbove + ValYBelow) / 2;
          }

          if (ScrY == 159)
          {
            IsYMagnificationCorrect = true;      
            prefs->MagDigY = ValY;      
          }
      }

      StrIToA(XPosT,ValX);
      StrIToA(YPosT,ValY);
      StrCopy(PosT,XPosT);
      StrCat(PosT,",");
      StrCat(PosT,YPosT);
      WinDrawChars(PosT,StrLen(PosT),110,40);
}

void DisplayCurrent(FormPtr frmP, AppPrefPtr prefs)
{
      char PosT[20],
              XPosT[10],
              YPosT[10];
      char *cTemp;

      char sTemp[100];
      
      Int32 ValX;
      Int32 ValY;
      //FieldPtr fieldP;
      //MemHandle textH;
      //MemPtr memP;
      //Char cText;
  
      RectangleType rP;

      //Clearing screen
      rP.topLeft.x = 0;
      rP.topLeft.y = 20;
      rP.extent.x = 160;
      rP.extent.y = 40;
      WinEraseRectangle(&rP,0);
      
      //Display Labels
      StrCopy(sTemp, "Digitizer (Width,Height): ");
      WinDrawChars(sTemp, StrLen(sTemp), 1, 25); 
      StrCopy(sTemp, "Magnification (X,Y) : ");
      WinDrawChars(sTemp, StrLen(sTemp), 1, 40);  
         
      ValX = prefs->DigMaxX;
      ValY = prefs->DigMaxY;
      StrIToA(XPosT,ValX);
      StrIToA(YPosT,ValY);
      StrCopy(PosT,XPosT);
      StrCat(PosT,",");
      StrCat(PosT,YPosT);
      WinDrawChars(PosT,StrLen(PosT),110,25);
      
      ValX = prefs->MagDigX;
      ValY = prefs->MagDigY;
      StrIToA(XPosT,ValX);
      StrIToA(YPosT,ValY);
      StrCopy(PosT,XPosT);
      StrCat(PosT,",");
      StrCat(PosT,YPosT);
      WinDrawChars(PosT,StrLen(PosT),110,40);
      
      //Fields
      /*
      fieldP = FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, FLD_ENABLE_CHAR));
      FrmSetFocus(frmP, FrmGetObjectIndex(frmP, FLD_ENABLE_CHAR));
      textH = FldGetTextHandle(fieldP);            
      FldSetTextHandle (fieldP, NULL);
      if (textH != NULL)
      {
        memP = MemHandleLock(textH);
        //memP = (MemPtr) prefs->EnableChar;
        prefs->EnableChar = 'A';
        StrVPrintF(cTemp, "%c", &prefs->EnableChar);
        memP = (MemPtr) cTemp;
        MemHandleUnlock(textH);          
        FldSetTextHandle(fieldP, textH);
        FldDrawField(fieldP);  
        //WinDrawChars(cTemp,StrLen(cTemp),90,90);
      }
      else
      {
         prefs->EnableChar = 'A';
         //StrVPrintF(cTemp, "%c", prefs->EnableChar);
         cTemp[0] = prefs->EnableChar;
         WinDrawChars(cTemp,StrLen(cTemp),0,100);
         WinDrawChars("1",1,0,120);
         FldSetTextHandle(fieldP, &cTemp[0]);
         FldDrawField(fieldP);  
         
      } 
      */
      SetFieldText(FLD_ENABLE_CHAR, &prefs->EnableChar);
      //FrmDrawForm(frmP);


}

void initPrefs(AppPrefPtr prefP)
{
/*
    prefP->IsEnabled = false;
    prefP->IsVisible = false;
    prefP->ScreenMaxX = 80;
    prefP->ScreenMaxY = 80;
    prefP->CurrentX = 10;
    prefP->CurrentY = 7;
*/
    prefP->DigMaxX = 100;
    prefP->DigMaxY = 100;
    prefP->MagDigX = 50;
    prefP->MagDigY = 50;
    prefP->EnableChar = '\\';

    savePrefs(prefP);
}

void savePrefs(AppPrefPtr prefP)
{
    PrefSetAppPreferences(CREATOR_ID, PREF_ID, PREF_VERSION, prefP, PREF_SIZE, PREF_SAVED);
}


void loadPrefs(AppPrefPtr prefP)
{
    Int32 found;
    UInt16 prefsSize = PREF_SIZE;

    found = PrefGetAppPreferences(CREATOR_ID, PREF_ID, prefP, &prefsSize, PREF_SAVED);

    if ((found == noPreferenceFound) || (prefsSize != PREF_SIZE))
    {
        initPrefs(prefP);
    }
}

static void SetFieldText(Int16 nFieldName, char * sNewText)
{
    FormPtr frmP = FrmGetActiveForm();
    FieldPtr fldP = FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, nFieldName));
    MemHandle oldH = FldGetTextHandle(fldP);
    int length = StrLen(sNewText) + 8;
    MemHandle h = MemHandleNew(length + 1);
    StrCopy(MemHandleLock(h), sNewText);
    MemHandleUnlock(h);
    //FldSetText(fldP, h, 0, length + 1);
    FldSetTextHandle(fldP, h);
    FldDrawField(fldP);
    if (oldH != NULL) 
        MemHandleFree(oldH);
} 

char *GetFieldText(Int16 nFieldName)
{
    char * sFieldText;
    FormPtr frmP = FrmGetActiveForm();
    FieldPtr fldP = FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, nFieldName));
    MemHandle h = FldGetTextHandle(fldP);
    if (h != NULL) 
    {
        sFieldText = MemHandleLock(h);
        MemHandleUnlock(h);
        /*
        int length = StrLen(p);
        if (length == 0) 
        {
            MemHandleUnlock(h);
            setDefaultText();
        }
        else
        {
            int i;
            for (i = 0; i < length/2; i++)
            {
                char t = p[length - 1 - i];
                p[length - 1 - i] = p[i];
                p[i] = t;
            }
            MemHandleUnlock(h);
            //FldSetText(fldP, h, 0, length + 1);
            FldSetTextHandle(fldP, h);
        }
        FrmDrawForm(frmP);
        */
    }
    else
    {
        sFieldText = NULL;
    }
    return sFieldText;
}